SET SERVEROUTPUT ON
SET TERMOUT ON
EXEC DBMS_OUTPUT.PUT_LINE('');
EXEC DBMS_OUTPUT.PUT_LINE('Creant taules pel magatzem de dades');
SET TERMOUT OFF
SET SERVEROUTPUT OFF

SET SERVEROUTPUT ON
SET TERMOUT ON
EXEC DBMS_OUTPUT.PUT_LINE(' Dimensi Botigues');
SET TERMOUT OFF
SET SERVEROUTPUT OFF

-- Crear la dimensi de botigues.
CREATE TABLE dimBotigues (
  id NUMBER PRIMARY KEY,
  codi NUMBER NOT NULL,
  nom VARCHAR2(100) NOT NULL,
  adreca VARCHAR2(200) NOT NULL,
  telefon VARCHAR2(9) NOT NULL,
  fax VARCHAR2(9) NOT NULL,
  correuE VARCHAR2(50) NOT NULL,
  clausurada DATE DEFAULT NULL
);

-- Crear la seqncia per generar l'identificador de la dimensi de botigues.
CREATE SEQUENCE dimBotigues_id
  START WITH 1
  INCREMENT BY 1;

-- Crear el disparador per establir l'identificador automticament, segons
-- la seqncia creada.
CREATE OR REPLACE TRIGGER dimBotigues_id_trigger
BEFORE INSERT
ON dimBotigues
REFERENCING NEW AS NEW
FOR EACH ROW
BEGIN
  SELECT dimBotigues_id.nextval INTO :NEW.id FROM dual;
END;
/

SET SERVEROUTPUT ON
SET TERMOUT ON
EXEC DBMS_OUTPUT.PUT_LINE(' Dimensi Empleats');
SET TERMOUT OFF
SET SERVEROUTPUT OFF

-- Crear la dimensi d'empleats.
CREATE TABLE dimEmpleats (
  id NUMBER PRIMARY KEY,
  nif VARCHAR2(9) NOT NULL,
  nom VARCHAR2(200) NOT NULL,
  baixa DATE DEFAULT NULL
);

-- Crear la seqncia per generar l'identificador de la dimensi d'empleats.
CREATE SEQUENCE dimEmpleats_id
  START WITH 1
  INCREMENT BY 1;

-- Crear el disparador per establir l'identificador automticament, segons
-- la seqncia creada.
CREATE OR REPLACE TRIGGER dimEmpleats_id_trigger
BEFORE INSERT
ON dimEmpleats
REFERENCING NEW AS NEW
FOR EACH ROW
BEGIN
  SELECT dimEmpleats_id.nextval INTO :NEW.id FROM dual;
END;
/

SET SERVEROUTPUT ON
SET TERMOUT ON
EXEC DBMS_OUTPUT.PUT_LINE(' Dimensi Vehicles');
SET TERMOUT OFF
SET SERVEROUTPUT OFF

-- Crear la dimensi de vehicles.
CREATE TABLE dimVehicles (
  id NUMBER PRIMARY KEY,
  vin VARCHAR2(17) NOT NULL,
  matricula VARCHAR2(7),
  marca VARCHAR2(30) NOT NULL,
  model VARCHAR2(50) NOT NULL,
  motor VARCHAR2(50) NOT NULL,
  equipament VARCHAR2(200) NOT NULL,
  color VARCHAR2(20) NOT NULL,
  kms NUMBER(8) DEFAULT 0 NOT NULL,
  CONSTRAINT vin_unique_vehicles UNIQUE (vin, matricula)
);

-- Crear la seqncia per generar l'identificador de la dimensi de vehicles.
CREATE SEQUENCE dimVehicles_id
  START WITH 1
  INCREMENT BY 1;

-- Crear el disparador per establir l'identificador automticament, segons
-- la seqncia creada.
CREATE OR REPLACE TRIGGER dimVehicles_id_trigger
BEFORE INSERT
ON dimVehicles
REFERENCING NEW AS NEW
FOR EACH ROW
BEGIN
  SELECT dimVehicles_id.nextval INTO :NEW.id FROM dual;
END;
/

SET SERVEROUTPUT ON
SET TERMOUT ON
EXEC DBMS_OUTPUT.PUT_LINE(' Dimensi Venedors');
SET TERMOUT OFF
SET SERVEROUTPUT OFF

-- Crear la dimensi de venedors.
CREATE TABLE dimVenedors (
  id NUMBER PRIMARY KEY,
  nif VARCHAR2(9) NOT NULL,
  nom VARCHAR2(100) NOT NULL,
  adreca VARCHAR2(200) NOT NULL,
  telefon VARCHAR2(9) NOT NULL,
  fax VARCHAR2(9) NOT NULL,
  correuE VARCHAR2(50) NOT NULL
);

-- Crear la seqncia per generar l'identificador de la dimensi de venedors.
CREATE SEQUENCE dimVenedors_id
  START WITH 1
  INCREMENT BY 1;

-- Crear el disparador per establir l'identificador automticament, segons
-- la seqncia creada.
CREATE OR REPLACE TRIGGER dimVenedors_id_trigger
BEFORE INSERT
ON dimVenedors
REFERENCING NEW AS NEW
FOR EACH ROW
BEGIN
  SELECT dimVenedors_id.nextval INTO :NEW.id FROM dual;
END;
/

SET SERVEROUTPUT ON
SET TERMOUT ON
EXEC DBMS_OUTPUT.PUT_LINE(' Dimensi Temps');
SET TERMOUT OFF
SET SERVEROUTPUT OFF

-- Crear la dimensi de temps.
CREATE TABLE dimTemps (
  id NUMBER PRIMARY KEY,
  dataDia DATE NOT NULL,
  anyData NUMBER NOT NULL,
  trimestre NUMBER NOT NULL,
  mes VARCHAR(9) NOT NULL,
  setmana NUMBER NOT NULL,
  diaSetmana VARCHAR(15) NOT NULL
);

-- Crear la seqncia per generar l'identificador de la dimensi de temps.
CREATE SEQUENCE dimTemps_id
  START WITH 1
  INCREMENT BY 1;

-- Crear el disparador per establir l'identificador automticament, segons
-- la seqncia creada.
CREATE OR REPLACE TRIGGER dimTemps_id_trigger
BEFORE INSERT
ON dimTemps
REFERENCING NEW AS NEW
FOR EACH ROW
BEGIN
  SELECT dimTemps_id.nextval INTO :NEW.id FROM dual;
END;
/

SET SERVEROUTPUT ON
SET TERMOUT ON
EXEC DBMS_OUTPUT.PUT_LINE(' Dimensi Comercials');
SET TERMOUT OFF
SET SERVEROUTPUT OFF

-- Crear la dimensi de comercials.
CREATE TABLE dimComercials (
  id NUMBER PRIMARY KEY,
  nif VARCHAR2(9) NOT NULL
);

-- Crear la seqncia per generar l'identificador de la dimensi de comercials.
CREATE SEQUENCE dimComercials_id
  START WITH 1
  INCREMENT BY 1;

-- Crear el disparador per establir l'identificador automticament, segons
-- la seqncia creada.
CREATE OR REPLACE TRIGGER dimComercials_id_trigger
BEFORE INSERT
ON dimComercials
REFERENCING NEW AS NEW
FOR EACH ROW
BEGIN
  SELECT dimComercials_id.nextval INTO :NEW.id FROM dual;
END;
/

SET SERVEROUTPUT ON
SET TERMOUT ON
EXEC DBMS_OUTPUT.PUT_LINE(' Dimensi Clients');
SET TERMOUT OFF
SET SERVEROUTPUT OFF

-- Crear la dimensi de clients.
CREATE TABLE dimClients (
  id NUMBER PRIMARY KEY,
  nif VARCHAR2(9) NOT NULL,
  nom VARCHAR2(100) NOT NULL,
  adreca VARCHAR2(200) NOT NULL,
  telefon VARCHAR2(9) NOT NULL,
  fax VARCHAR2(9) NOT NULL,
  correuE VARCHAR2(50) NOT NULL
);

-- Crear la seqncia per generar l'identificador de la dimensi de clients.
CREATE SEQUENCE dimClients_id
  START WITH 1
  INCREMENT BY 1;

-- Crear el disparador per establir l'identificador automticament, segons
-- la seqncia creada.
CREATE OR REPLACE TRIGGER dimClients_id_trigger
BEFORE INSERT
ON dimClients
REFERENCING NEW AS NEW
FOR EACH ROW
BEGIN
  SELECT dimClients_id.nextval INTO :NEW.id FROM dual;
END;
/

SET SERVEROUTPUT ON
SET TERMOUT ON
EXEC DBMS_OUTPUT.PUT_LINE(' Dimensi Mecanics');
SET TERMOUT OFF
SET SERVEROUTPUT OFF

-- Crear la dimensi de mecnics.
CREATE TABLE dimMecanics (
  id NUMBER PRIMARY KEY,
  nif VARCHAR2(9) NOT NULL
);

-- Crear la seqncia per generar l'identificador de la dimensi de mecnics.
CREATE SEQUENCE dimMecanics_id
  START WITH 1
  INCREMENT BY 1;

-- Crear el disparador per establir l'identificador automticament, segons
-- la seqncia creada.
CREATE OR REPLACE TRIGGER dimMecanics_id_trigger
BEFORE INSERT
ON dimMecanics
REFERENCING NEW AS NEW
FOR EACH ROW
BEGIN
  SELECT dimMecanics_id.nextval INTO :NEW.id FROM dual;
END;
/

SET SERVEROUTPUT ON
SET TERMOUT ON
EXEC DBMS_OUTPUT.PUT_LINE(' Dimensi Hores');
SET TERMOUT OFF
SET SERVEROUTPUT OFF

-- Crear la dimensi d'hores.
CREATE TABLE dimHores (
  id NUMBER PRIMARY KEY,
  idTemps NUMBER NOT NULL,
  temps TIMESTAMP(9) NOT NULL,
  hora NUMBER NOT NULL,
  minut NUMBER NOT NULL,
  segon NUMBER NOT NULL,
  CONSTRAINT fk_dimTemps_dimHores FOREIGN KEY (idTemps) REFERENCES dimTemps(id)
);

-- Crear la seqncia per generar l'identificador de la dimensi d'hores.
CREATE SEQUENCE dimHores_id
  START WITH 1
  INCREMENT BY 1;

-- Crear el disparador per establir l'identificador automticament, segons
-- la seqncia creada.
CREATE OR REPLACE TRIGGER dimHores_id_trigger
BEFORE INSERT
ON dimHores
REFERENCING NEW AS NEW
FOR EACH ROW
BEGIN
  SELECT dimHores_id.nextval INTO :NEW.id FROM dual;
END;
/

SET SERVEROUTPUT ON
SET TERMOUT ON
EXEC DBMS_OUTPUT.PUT_LINE(' Taula de fets Compres');
SET TERMOUT OFF
SET SERVEROUTPUT OFF

-- Crear la taula de fets de compres.
CREATE TABLE fetsCompres (
  id NUMBER PRIMARY KEY,
  idBotiga NUMBER NOT NULL,
  idEmpleat NUMBER NOT NULL,
  idVenedor NUMBER NOT NULL,
  idVehicle NUMBER NOT NULL,
  idTemps NUMBER NOT NULL,
  import NUMBER(10,2) NOT NULL,
  CONSTRAINT fk_dimBotigues_fetsCompres FOREIGN KEY (idBotiga) REFERENCES dimBotigues(id),
  CONSTRAINT fk_dimEmpleat_fetsCompres FOREIGN KEY (idEmpleat) REFERENCES dimEmpleats(id),
  CONSTRAINT fk_dimVenedor_fetsCompres FOREIGN KEY (idVenedor) REFERENCES dimVenedors(id),
  CONSTRAINT fk_dimVehicle_fetsCompres FOREIGN KEY (idVehicle) REFERENCES dimVehicles(id),
  CONSTRAINT fk_dimTemps_fetsCompres FOREIGN KEY (idTemps) REFERENCES dimTemps(id)
);

-- Crear la seqncia per generar l'identificador de la taula de fets de compres.
CREATE SEQUENCE fetsCompres_id
  START WITH 1
  INCREMENT BY 1;

-- Crear el disparador per establir l'identificador automticament, segons
-- la seqncia creada.
CREATE OR REPLACE TRIGGER fetsCompres_id_trigger
BEFORE INSERT
ON fetsCompres
REFERENCING NEW AS NEW
FOR EACH ROW
BEGIN
  SELECT fetsCompres_id.nextval INTO :NEW.id FROM dual;
END;
/

SET SERVEROUTPUT ON
SET TERMOUT ON
EXEC DBMS_OUTPUT.PUT_LINE(' Taula de fets Vendes');
SET TERMOUT OFF
SET SERVEROUTPUT OFF

-- Crear la taula de fets de vendes.
CREATE TABLE fetsVendes (
  id NUMBER PRIMARY KEY,
  idBotiga NUMBER NOT NULL,
  idComercial NUMBER NOT NULL,
  idClient NUMBER NOT NULL,
  idVehicle NUMBER NOT NULL,
  idTemps NUMBER NOT NULL,
  import NUMBER(10,2) NOT NULL,
  CONSTRAINT fk_dimBotigues_fetsVendes FOREIGN KEY (idBotiga) REFERENCES dimBotigues(id),
  CONSTRAINT fk_dimComercials_fetsVendes FOREIGN KEY (idComercial) REFERENCES dimComercials(id),
  CONSTRAINT fk_dimClients_fetsVendes FOREIGN KEY (idClient) REFERENCES dimClients(id),
  CONSTRAINT fk_dimVehicle_fetsVendes FOREIGN KEY (idVehicle) REFERENCES dimVehicles(id),
  CONSTRAINT fk_dimTemps_fetsVendes FOREIGN KEY (idTemps) REFERENCES dimTemps(id)
);

-- Crear la seqncia per generar l'identificador de la taula de fets de vendes.
CREATE SEQUENCE fetsVendes_id
  START WITH 1
  INCREMENT BY 1;

-- Crear el disparador per establir l'identificador automticament, segons
-- la seqncia creada.
CREATE OR REPLACE TRIGGER fetsVendes_id_trigger
BEFORE INSERT
ON fetsVendes
REFERENCING NEW AS NEW
FOR EACH ROW
BEGIN
  SELECT fetsVendes_id.nextval INTO :NEW.id FROM dual;
END;
/

SET SERVEROUTPUT ON
SET TERMOUT ON
EXEC DBMS_OUTPUT.PUT_LINE(' Taula de fets Revisions');
SET TERMOUT OFF
SET SERVEROUTPUT OFF

-- Crear la taula de fets de revisions.
CREATE TABLE fetsRevisions (
  id NUMBER PRIMARY KEY,
  idBotiga NUMBER NOT NULL,
  idMecanic NUMBER NOT NULL,
  idClient NUMBER NOT NULL,
  idVehicle NUMBER NOT NULL,
  idHoraEntrada NUMBER NOT NULL,
  idHoraSortida NUMBER,
  import NUMBER(10,2),
  tempsEmpleat NUMBER,
  CONSTRAINT fk_dimBotigues_fetsRevisions FOREIGN KEY (idBotiga) REFERENCES dimBotigues(id),
  CONSTRAINT fk_dimMecanics_fetsRevisions FOREIGN KEY (idMecanic) REFERENCES dimMecanics(id),
  CONSTRAINT fk_dimClients_fetsRevisions FOREIGN KEY (idClient) REFERENCES dimClients(id),
  CONSTRAINT fk_dimVehicles_fetsRevisions FOREIGN KEY (idVehicle) REFERENCES dimVehicles(id),
  CONSTRAINT fk_dimHores_fetsRevisions_Ent FOREIGN KEY (idHoraEntrada) REFERENCES dimHores(id),
  CONSTRAINT fk_dimHores_fetsRevisions_Sor FOREIGN KEY (idHoraSortida) REFERENCES dimHores(id)
);

-- Crear la seqncia per generar l'identificador de la taula de fets de revisions.
CREATE SEQUENCE fetsRevisions_id
  START WITH 1
  INCREMENT BY 1;
  
-- Crear el disparador per establir l'identificador automticament, segons
-- la seqncia creada.
CREATE OR REPLACE TRIGGER fetsRevisions_id_trigger
BEFORE INSERT
ON fetsRevisions
REFERENCING NEW AS NEW
FOR EACH ROW
BEGIN
  SELECT fetsRevisions_id.nextval INTO :NEW.id FROM dual;
END;
/

SET SERVEROUTPUT ON
SET TERMOUT ON
EXEC DBMS_OUTPUT.PUT_LINE(' Taula de fets Reparacions');
SET TERMOUT OFF
SET SERVEROUTPUT OFF

-- Crear la taula de fets de reparacions.
CREATE TABLE fetsReparacions (
  id NUMBER PRIMARY KEY,
  idBotiga NUMBER NOT NULL,
  idMecanic NUMBER NOT NULL,
  idClient NUMBER NOT NULL,
  idVehicle NUMBER NOT NULL,
  motiu VARCHAR(200) NOT NULL,
  idHoraEntrada NUMBER NOT NULL,
  idHoraSortida NUMBER,
  import NUMBER(10,2),
  tempsEmpleat NUMBER,
  CONSTRAINT fk_dimBotigues_fetsRepars FOREIGN KEY (idBotiga) REFERENCES dimBotigues(id),
  CONSTRAINT fk_dimMecanics_fetsRepars FOREIGN KEY (idMecanic) REFERENCES dimMecanics(id),
  CONSTRAINT fk_dimClients_fetsRepars FOREIGN KEY (idClient) REFERENCES dimClients(id),
  CONSTRAINT fk_dimVehicles_fetsRepars FOREIGN KEY (idVehicle) REFERENCES dimVehicles(id),
  CONSTRAINT fk_dimHores_fetsRepars_Ent FOREIGN KEY (idHoraEntrada) REFERENCES dimHores(id),
  CONSTRAINT fk_dimHores_fetsRepars_Sor FOREIGN KEY (idHoraSortida) REFERENCES dimHores(id)
);

-- Crear la seqncia per generar l'identificador de la taula de fets de reparacions.
CREATE SEQUENCE fetsReparacions_id
  START WITH 1
  INCREMENT BY 1;
  
-- Crear el disparador per establir l'identificador automticament, segons
-- la seqncia creada.
CREATE OR REPLACE TRIGGER fetsReparacions_id_trigger
BEFORE INSERT
ON fetsReparacions
REFERENCING NEW AS NEW
FOR EACH ROW
BEGIN
  SELECT fetsReparacions_id.nextval INTO :NEW.id FROM dual;
END;
/