SET SERVEROUTPUT ON
SET TERMOUT ON
EXEC DBMS_OUTPUT.PUT_LINE('');
EXEC DBMS_OUTPUT.PUT_LINE('Creant vistes per estadstiques');
SET TERMOUT OFF
SET SERVEROUTPUT OFF

SET SERVEROUTPUT ON
SET TERMOUT ON
SHOW ERRORS;
EXEC DBMS_OUTPUT.PUT_LINE('');
EXEC DBMS_OUTPUT.PUT_LINE(' Vista Compres per botiga');
SET TERMOUT OFF
SET SERVEROUTPUT OFF

-- Crear la vista de compres per botiga.
CREATE OR REPLACE VIEW compresPerBotiga AS
  SELECT botiga.nom, COUNT(compra.id) Compres
    FROM fetsCompres compra
    JOIN dimBotigues botiga
     ON compra.idBotiga = botiga.id
    GROUP BY botiga.nom;

SET SERVEROUTPUT ON
SET TERMOUT ON
SHOW ERRORS;
EXEC DBMS_OUTPUT.PUT_LINE('');
EXEC DBMS_OUTPUT.PUT_LINE(' Vista Compres per marca');
SET TERMOUT OFF
SET SERVEROUTPUT OFF

-- Crear la vista de compres per marca.
CREATE OR REPLACE VIEW compresPerMarca AS
  SELECT vehicle.marca, COUNT(compra.id) Compres
    FROM fetsCompres compra
    JOIN dimVehicles vehicle
     ON compra.idVehicle = vehicle.id
    GROUP BY vehicle.marca;

SET SERVEROUTPUT ON
SET TERMOUT ON
SHOW ERRORS;
EXEC DBMS_OUTPUT.PUT_LINE('');
EXEC DBMS_OUTPUT.PUT_LINE(' Vista Compres per empleat');
SET TERMOUT OFF
SET SERVEROUTPUT OFF

-- Crear la vista de compres per empleat.
CREATE OR REPLACE VIEW compresPerEmpleat AS
  SELECT empleat.nom, COUNT(compra.id) Compres
    FROM fetsCompres compra
    JOIN dimEmpleats empleat
     ON compra.idEmpleat = empleat.id
    GROUP BY empleat.nom;

SET SERVEROUTPUT ON
SET TERMOUT ON
SHOW ERRORS;
EXEC DBMS_OUTPUT.PUT_LINE('');
EXEC DBMS_OUTPUT.PUT_LINE(' Vista Vehicles per novetat');
SET TERMOUT OFF
SET SERVEROUTPUT OFF

-- Crear la vista de vehicles per novetat.
CREATE OR REPLACE VIEW vehiclesPerNovetat AS
  SELECT 'Nous' Novetat, COUNT(*) Quantitat
    FROM CONCESSIONARIDWH.dimVehicles 
    WHERE matricula = ' '
  UNION
  SELECT 'Segona m', COUNT(*) 
    FROM CONCESSIONARIDWH.dimVehicles 
    WHERE matricula != ' ';

SET SERVEROUTPUT ON
SET TERMOUT ON
SHOW ERRORS;
EXEC DBMS_OUTPUT.PUT_LINE('');
EXEC DBMS_OUTPUT.PUT_LINE(' Vista Vendes per botiga');
SET TERMOUT OFF
SET SERVEROUTPUT OFF

-- Crear la vista de vendes per botiga.
CREATE OR REPLACE VIEW vendesPerBotiga AS
  SELECT botiga.nom, COUNT(venda.id) Vendes
    FROM fetsVendes venda
    JOIN dimBotigues botiga
     ON venda.idBotiga = botiga.id
    GROUP BY botiga.nom;

SET SERVEROUTPUT ON
SET TERMOUT ON
SHOW ERRORS;
EXEC DBMS_OUTPUT.PUT_LINE('');
EXEC DBMS_OUTPUT.PUT_LINE(' Vista Vendes per comercial');
SET TERMOUT OFF
SET SERVEROUTPUT OFF

-- Crear la vista de vendes per comercial.
CREATE OR REPLACE VIEW vendesPerComercial AS
  SELECT empleat.nom, COUNT(venda.id) Vendes
    FROM fetsVendes venda
    JOIN dimComercials comercial
     ON venda.idComercial = comercial.id
    JOIN dimEmpleats empleat
     ON comercial.nif = empleat.nif
    GROUP BY empleat.nom;

SET SERVEROUTPUT ON
SET TERMOUT ON
SHOW ERRORS;
EXEC DBMS_OUTPUT.PUT_LINE('');
EXEC DBMS_OUTPUT.PUT_LINE(' Vista Vehicles venuts per novetat');
SET TERMOUT OFF
SET SERVEROUTPUT OFF

-- Crear la vista de vendes per novetat.
CREATE OR REPLACE VIEW vehiclesVenutsPerNovetat AS
  SELECT 'Nous' Novetat, COUNT(*) Quantitat
    FROM CONCESSIONARIDWH.dimVehicles vehicles
    JOIN CONCESSIONARIDWH.fetsVendes vendes
     ON vehicles.id = vendes.idVehicle
    WHERE vehicles.matricula = ' '
  UNION
  SELECT 'Segona m', COUNT(*) 
    FROM CONCESSIONARIDWH.dimVehicles vehicles
    JOIN CONCESSIONARIDWH.fetsVendes vendes
     ON vehicles.id = vendes.idVehicle
    WHERE vehicles.matricula != ' ';

SET SERVEROUTPUT ON
SET TERMOUT ON
SHOW ERRORS;
EXEC DBMS_OUTPUT.PUT_LINE('');
EXEC DBMS_OUTPUT.PUT_LINE(' Vista Revisions per botiga');
SET TERMOUT OFF
SET SERVEROUTPUT OFF

-- Crear la vista de revisions per botiga.
CREATE OR REPLACE VIEW revisionsPerBotiga AS
  SELECT botiga.nom, COUNT(revisio.id) Revisions
    FROM CONCESSIONARIDWH.fetsRevisions revisio
    JOIN CONCESSIONARIDWH.dimBotigues botiga
     ON revisio.idBotiga = botiga.id
    GROUP BY botiga.nom;

SET SERVEROUTPUT ON
SET TERMOUT ON
SHOW ERRORS;
EXEC DBMS_OUTPUT.PUT_LINE('');
EXEC DBMS_OUTPUT.PUT_LINE(' Vista Revisions per mecnic');
SET TERMOUT OFF
SET SERVEROUTPUT OFF

-- Crear la vista de revisions per mecnic.
CREATE OR REPLACE VIEW revisionsPerMecanic AS
  SELECT empleat.nom, COUNT(revisio.id) Revisions
    FROM CONCESSIONARIDWH.fetsRevisions revisio
    JOIN CONCESSIONARIDWH.dimMecanics mecanic
     ON revisio.idMecanic = mecanic.id
    JOIN CONCESSIONARIDWH.dimEmpleats empleat
     ON mecanic.nif = empleat.nif
    GROUP BY empleat.nom;

SET SERVEROUTPUT ON
SET TERMOUT ON
SHOW ERRORS;
EXEC DBMS_OUTPUT.PUT_LINE('');
EXEC DBMS_OUTPUT.PUT_LINE(' Vista Reparacions per botiga');
SET TERMOUT OFF
SET SERVEROUTPUT OFF

-- Crear la vista de reparacions per botiga.
CREATE OR REPLACE VIEW reparacionsPerBotiga AS
  SELECT botiga.nom, COUNT(reparacio.id) Reparacions
    FROM CONCESSIONARIDWH.fetsReparacions reparacio
    JOIN CONCESSIONARIDWH.dimBotigues botiga
     ON reparacio.idBotiga = botiga.id
    GROUP BY botiga.nom;

SET SERVEROUTPUT ON
SET TERMOUT ON
SHOW ERRORS;
EXEC DBMS_OUTPUT.PUT_LINE('');
EXEC DBMS_OUTPUT.PUT_LINE(' Vista Reparacions per mecnic');
SET TERMOUT OFF
SET SERVEROUTPUT OFF

-- Crear la vista de reparacions per mecnic.
CREATE OR REPLACE VIEW reparacionsPerMecanic AS
  SELECT empleat.nom, COUNT(reparacio.id) Reparacions
    FROM CONCESSIONARIDWH.fetsReparacions reparacio
    JOIN CONCESSIONARIDWH.dimMecanics mecanic
     ON reparacio.idMecanic = mecanic.id
    JOIN CONCESSIONARIDWH.dimEmpleats empleat
     ON mecanic.nif = empleat.nif
    GROUP BY empleat.nom;

SET SERVEROUTPUT ON
SET TERMOUT ON
SHOW ERRORS;
EXEC DBMS_OUTPUT.PUT_LINE('');
EXEC DBMS_OUTPUT.PUT_LINE(' Avisos');
SET TERMOUT OFF
SET SERVEROUTPUT OFF

-- Crear la vista de reparacions per mecnic.
CREATE OR REPLACE VIEW avisos AS
  SELECT
    dimTemps.dataDia,
    dimClients.nom,
    dimClients.telefon,
    dimClients.correuE,
    dimVehicles.matricula
  FROM fetsVendes
  JOIN dimClients ON dimClients.id = fetsVendes.idClient
  JOIN dimTemps ON dimTemps.id = fetsVendes.idTemps
  JOIN dimVehicles ON dimVehicles.id = fetsVendes.idVehicle
  WHERE dimTemps.dataDia <= SYSDATE - INTERVAL '4' YEAR
    AND fetsVendes.idVehicle NOT IN (
      SELECT idVehicle
      FROM fetsRevisions
      JOIN dimHores ON dimHores.id = fetsRevisions.idHoraSortida
      JOIN dimTemps ON dimTemps.id = dimHores.idTemps
      WHERE dimTemps.dataDia > SYSDATE - INTERVAL '1' YEAR
    )
  UNION
  SELECT
    dimTemps.dataDia,
    dimClients.nom,
    dimClients.telefon,
    dimClients.correuE,
    dimVehicles.matricula
  FROM fetsRevisions
  JOIN dimClients ON dimClients.id = fetsRevisions.idClient
  JOIN dimVehicles ON dimVehicles.id = fetsRevisions.idVehicle
  JOIN dimHores ON dimHores.id = fetsRevisions.idHoraSortida
  JOIN dimTemps ON dimTemps.id = dimHores.idTemps
  WHERE dimTemps.dataDia <= SYSDATE - INTERVAL '1' YEAR
  UNION
  SELECT
    dimTemps.dataDia,
    dimClients.nom,
    dimClients.telefon,
    dimClients.correuE,
    dimVehicles.matricula
  FROM fetsReparacions
  JOIN dimClients ON dimClients.id = fetsReparacions.idClient
  JOIN dimVehicles ON dimVehicles.id = fetsReparacions.idVehicle
  JOIN dimHores ON dimHores.id = fetsReparacions.idHoraSortida
  JOIN dimTemps ON dimTemps.id = dimHores.idTemps
  WHERE dimTemps.dataDia <= SYSDATE - INTERVAL '1' YEAR
    AND fetsReparacions.idVehicle NOT IN (
      SELECT idVehicle
      FROM fetsRevisions
      JOIN dimHores ON dimHores.id = fetsRevisions.idHoraSortida
      JOIN dimTemps ON dimTemps.id = dimHores.idTemps
      WHERE dimTemps.dataDia > SYSDATE - INTERVAL '1' YEAR
    );

SET SERVEROUTPUT ON
SET TERMOUT ON
SHOW ERRORS;
SET TERMOUT OFF
SET SERVEROUTPUT OFF