SET SERVEROUTPUT ON
SET TERMOUT ON
EXEC DBMS_OUTPUT.PUT_LINE('');
EXEC DBMS_OUTPUT.PUT_LINE('  Tests tasca 110: Inauguraci i clausura de botigues (ETL).');
SET TERMOUT OFF
SET SERVEROUTPUT OFF

-- Declaraci de tipus per les validacions de la inauguraci i clausura.
CREATE OR REPLACE TYPE tasca110_test_obj UNDER sys.pluto_obj(
  MEMBER PROCEDURE setup_testing,
  MEMBER PROCEDURE test_etl,
  MEMBER PROCEDURE teardown_testing,
  CONSTRUCTOR FUNCTION tasca110_test_obj
    RETURN SELF AS RESULT
) INSTANTIABLE NOT FINAL;
/

SET SERVEROUTPUT ON
SET TERMOUT ON
SHOW ERRORS;
SET TERMOUT OFF
SET SERVEROUTPUT OFF

CREATE OR REPLACE TYPE BODY tasca110_test_obj IS
  MEMBER PROCEDURE setup_testing IS
  BEGIN
    NULL;
  END setup_testing;

  MEMBER PROCEDURE test_etl IS
    n_botigues  INT := 0;
    n_botigues2 INT := 0;
    codiBotiga  INT := 0;
    codiBotiga2 INT := 0;
  BEGIN
    inauguracio('Badal,81', 'C. Badal, 81', '937767769', '937767770', 'badal81@citroen.es');
    SELECT MAX(codi) INTO codiBotiga FROM botigues;
    SELECT COUNT(*) INTO n_botigues FROM concessionariDWH.dimBotigues;
    concessionariDWH.etl;
    SELECT COUNT(*) INTO n_botigues2 FROM concessionariDWH.dimBotigues;
    m_util_object.ok(
      test_passed => ( n_botigues2 = n_botigues + 1 ),
      test_label  => 'Comptar una inauguraci'
    );
    inauguracio('Badal,82', 'C. Badal, 82', '937767769', '937767770', 'badal81@citroen.es');
    SELECT MAX(codi) INTO codiBotiga2 FROM botigues;
    clausura(codiBotiga, codiBotiga2);
    SELECT COUNT(*) INTO n_botigues FROM concessionariDWH.dimBotigues;
    concessionariDWH.etl;
    SELECT COUNT(*) INTO n_botigues2 FROM concessionariDWH.dimBotigues WHERE clausurada IS NOT NULL;
    m_util_object.ok(
      test_passed => ( n_botigues2 = n_botigues AND NOT n_botigues = 0 ),
      test_label  => 'Comptar una clausura'
    );
  END test_etl;

  -- Desprs de cada test, es desfan els canvis.
  MEMBER PROCEDURE teardown_testing IS
  BEGIN
    ROLLBACK;
  END teardown_testing;

  -- Aquest s el constructor.
  CONSTRUCTOR FUNCTION tasca110_test_obj
    RETURN SELF AS RESULT IS
  BEGIN
    m_util_object := sys.pluto_util_obj();
    RETURN;
  END tasca110_test_obj;
END;
/

SET SERVEROUTPUT ON
SET TERMOUT ON
SHOW ERRORS;
SET TERMOUT OFF
SET SERVEROUTPUT OFF

-- Es realitza un procediment per executar el test.
CREATE OR REPLACE PROCEDURE runTeststasca110 IS
  ut_obj tasca110_test_obj := tasca110_test_obj();
BEGIN
  ut_obj.run_tests;
END;
/

SET SERVEROUTPUT ON
SET TERMOUT ON
SHOW ERRORS;
SET TERMOUT OFF
SET SERVEROUTPUT OFF