SET SERVEROUTPUT ON
SET TERMOUT ON
EXEC DBMS_OUTPUT.PUT_LINE('  Tests tasca 53: Registre.');
SET TERMOUT OFF
SET SERVEROUTPUT OFF

-- Declaraci de tipus per les validacions del registre.
CREATE OR REPLACE TYPE tasca53_test_obj UNDER sys.pluto_obj(
  MEMBER PROCEDURE startup_testing,
  MEMBER PROCEDURE test_log,
  MEMBER PROCEDURE teardown_testing,
  CONSTRUCTOR FUNCTION tasca53_test_obj
    RETURN SELF AS RESULT
) INSTANTIABLE NOT FINAL;
/

SET SERVEROUTPUT ON
SET TERMOUT ON
SHOW ERRORS;
SET TERMOUT OFF
SET SERVEROUTPUT OFF

-- Declaraci del cos de les validacions del registre.
CREATE OR REPLACE TYPE BODY tasca53_test_obj IS
  -- En el setup, es creen alguns registres que els tests poquin utilitzar.
  MEMBER PROCEDURE startup_testing IS
  BEGIN
    NULL;
  END startup_testing;

  -- Aquest test fa un registre i comprova que s'ha afegit.
  MEMBER PROCEDURE test_log IS
    n_logs      INT := 0;
    n_logs2     INT := 0;
    o_atribut   concessionari.atribut;
    v_tAtributs concessionari.tAtributs;
  BEGIN
    SELECT COUNT(*) INTO n_logs FROM registres;
    v_tAtributs := concessionari.tAtributs();
    o_atribut   := concessionari.atribut('nomTasca','tasca53','varchar2');
    v_tAtributs.EXTEND;
    v_tAtributs(v_tAtributs.LAST) := o_atribut;
    registra('Test',v_tAtributs);
    SELECT COUNT(*) INTO n_logs2 FROM registres;
    m_util_object.ok(
      test_passed => ( n_logs2 = n_logs + 1 ),
      test_label  => 'Afegir un log'
    );
  END test_log;

  -- Desprs de cada test, es desfan els canvis.
  MEMBER PROCEDURE teardown_testing IS
  BEGIN
    ROLLBACK;
  END teardown_testing;

  -- Aquest s el constructor.
  CONSTRUCTOR FUNCTION tasca53_test_obj
    RETURN SELF AS RESULT IS
  BEGIN
    m_util_object := sys.pluto_util_obj();
    RETURN;
  END tasca53_test_obj;
END;
/

SET SERVEROUTPUT ON
SET TERMOUT ON
SHOW ERRORS;
SET TERMOUT OFF
SET SERVEROUTPUT OFF

-- Es realitza un procediment per executar el test.
CREATE OR REPLACE PROCEDURE runTestsTasca53 IS
  ut_obj tasca53_test_obj := tasca53_test_obj();
BEGIN
  ut_obj.run_tests;
END;
/

SET SERVEROUTPUT ON
SET TERMOUT ON
SHOW ERRORS;
SET TERMOUT OFF
SET SERVEROUTPUT OFF