SET SERVEROUTPUT ON
SET TERMOUT ON
EXEC DBMS_OUTPUT.PUT_LINE('');
EXEC DBMS_OUTPUT.PUT_LINE('  Tests tasca 98: Avisos.');
SET TERMOUT OFF
SET SERVEROUTPUT OFF

-- Declaraci de tipus per les validacions del registre.
CREATE OR REPLACE TYPE tasca98_test_obj UNDER sys.pluto_obj(
  MEMBER PROCEDURE setup_testing,
  MEMBER PROCEDURE test_log,
  MEMBER PROCEDURE teardown_testing,
  CONSTRUCTOR FUNCTION tasca98_test_obj
    RETURN SELF AS RESULT
) INSTANTIABLE NOT FINAL;
/

SET SERVEROUTPUT ON
SET TERMOUT ON
SHOW ERRORS;
SET TERMOUT OFF
SET SERVEROUTPUT OFF

-- Declaraci del cos de les validacions del registre.
CREATE OR REPLACE TYPE BODY tasca98_test_obj IS
  -- En el setup, es creen alguns registres que els tests poquin utilitzar.
  MEMBER PROCEDURE setup_testing IS
  BEGIN
    INSERT INTO botigues VALUES (
      NULL,
      'Badal,81',
      'C. Badal, 81',
      '937767769',
      '937767770',
      'badal81@citroen.es'
    );
    INSERT INTO empleats VALUES (
      '10902989E',
      'Josep',
      (
        SELECT MAX(codi)
        FROM botigues
      ),
      'Y'
    );
    INSERT INTO comercials VALUES (
      '10902989E'
    );
    INSERT INTO empleats VALUES (
      '10902999E',
      'Marc',
      (
        SELECT MAX(codi)
        FROM botigues
      ),
      'Y'
    );
    INSERT INTO mecanics VALUES (
      '10902999E'
    );
    INSERT INTO venedors VALUES (
      '90909091D',
      'Citroen España',
      'c. Vigo',
      '986574833',
      '986574834',
      'fabrica@citroen.es'
    );
    INSERT INTO clients VALUES (
      '90909091D',
      'Manel',
      'c. Vigo',
      '986574833',
      '986574834',
      'manel@gmail.com'
    );
    INSERT INTO clients VALUES (
      '90909092D',
      'Joel',
      'c. Vigo',
      '986574834',
      '986574834',
      'joel@gmail.com'
    );
    INSERT INTO clients VALUES (
      '90909093D',
      'Sergi',
      'c. Vigo',
      '986574835',
      '986574834',
      'sergi@gmail.com'
    );
  END setup_testing;

  -- Aquest test fa un registre i comprova que s'ha afegit.
  MEMBER PROCEDURE test_log IS
    n_clients  int := 0;
    n_clients2 int := 0;
  BEGIN
    compra(
      '10902989E',
      '90909091D',
      '7888738395HG9798D',
      '1449HMC',
      'Citroën',
      'C4',
      '1.9 HDI',
      'A/C',
      'Blanco Blanquisse',
      TO_DATE('20121029','YYYYMMDD'),
      16000
    );
    venda(
      '10902989E',
      '90909091D',
      '7888738395HG9798D',
      TO_DATE('20081029','YYYYMMDD'),
      16000
    );
    INSERT INTO vehicles VALUES (
      '7888738395HG9799D',
      'C4',
      'Citroën',
      '1.9 HDI',
      'A/C',
      'Blanco Blanquisse',
      500
    );
    INSERT INTO matricules VALUES (
      '1449HMD',
      '7888738395HG9799D'
    );
    INSERT INTO revisions VALUES (
      '10902999E',
      '90909092D',
      '7888738395HG9799D',
      TO_DATE('20111029','YYYYMMDD'),
      TO_DATE('20111030','YYYYMMDD'),
      200
    );
    registra(
      'entraRevisio',
      tAtributs(
        atribut(
          'nifMecanic',
          '10902999E',
          'VARCHAR2'
        ),
        atribut(
          'nifClient',
          '90909092D',
          'VARCHAR2'
        ),
        atribut(
          'vin',
          '7888738395HG9799D',
          'VARCHAR2'
        ),
        atribut(
          'entrada',
          TO_DATE(
            '20111029',
            'YYYYMMDD'
          ),
          'DATE'
        )
      )
    );
    registra(
      'surtRevisio',
      tAtributs(
        atribut(
          'nifMecanic',
          '10902999E',
          'VARCHAR2'
        ),
        atribut(
          'nifClient',
          '90909092D',
          'VARCHAR2'
        ),
        atribut(
          'vin',
          '7888738395HG9799D',
          'VARCHAR2'
        ),
        atribut(
          'sortida',
          TO_DATE(
            '20111030',
            'YYYYMMDD'
          ),
          'DATE'
        ),
        atribut(
          'import',
          200,
          'NUMBER'
        )
      )
    );
    INSERT INTO vehicles VALUES (
      '7888738395HG9800D',
      'C4',
      'Citroën',
      '1.9 HDI',
      'A/C',
      'Blanco Blanquisse',
      500
    );
    INSERT INTO matricules VALUES (
      '1450HMD',
      '7888738395HG9800D'
    );
    INSERT INTO reparacions VALUES (
      '10902999E',
      '90909093D',
      '7888738395HG9800D',
      'reparacio',
      TO_DATE(
        '20111029',
        'YYYYMMDD'
      ),
      TO_DATE(
        '20111030',
        'YYYYMMDD'
      ),
      200
    );
    registra(
      'entraReparacio',
      tAtributs(
        atribut(
          'nifMecanic',
          '10902999E',
          'VARCHAR2'
        ),
        atribut(
          'nifClient',
          '90909093D',
          'VARCHAR2'
        ),
        atribut(
          'vin',
          '7888738395HG9800D',
          'VARCHAR2'
        ),
        atribut(
          'entrada',
          TO_DATE(
            '20111029',
            'YYYYMMDD'
          ),
          'DATE'
        ),
        atribut(
          'motiu',
          'reparacio',
          'VARCHAR2'
        )
      )
    );
    registra(
      'surtReparacio',
      tAtributs(
        atribut(
          'nifMecanic',
          '10902999E',
          'VARCHAR2'
        ),
        atribut(
          'nifClient',
          '90909093D',
          'VARCHAR2'
        ),
        atribut(
          'vin',
          '7888738395HG9800D',
          'VARCHAR2'
        ),
        atribut(
          'sortida',
          TO_DATE(
            '20111030',
            'YYYYMMDD'
          ),
          'DATE'
        ),
        atribut(
          'import',
          200,
          'NUMBER'
        )
      )
    );
    concessionariDWH.etl;
    SELECT COUNT(*)
    INTO n_clients
    FROM concessionariDWH.avisos;
    entraRevisio('10902999E','90909091D','7888738395HG9798D','1449HMC','C4','Citroën','1.9 HDI','A/C','Blanco Blanquisse',500);
    surtRevisio('10902999E','90909091D','7888738395HG9798D',200);
    concessionariDWH.etl;
    SELECT COUNT(*)
    INTO n_clients2
    FROM concessionariDWH.avisos;
    m_util_object.ok(
      test_passed => n_clients = n_clients2 + 1,
      test_label  => 'Avisos'
    );   
  END test_log;

  -- Desprs de cada test, es desfan els canvis.
  MEMBER PROCEDURE teardown_testing IS
  BEGIN
    ROLLBACK;
  END teardown_testing;

  -- Aquest s el constructor.
  CONSTRUCTOR FUNCTION tasca98_test_obj
    RETURN SELF AS RESULT IS
  BEGIN
    m_util_object := sys.pluto_util_obj();
    RETURN;
  END tasca98_test_obj;
END;
/

SET SERVEROUTPUT ON
SET TERMOUT ON
SHOW ERRORS;
SET TERMOUT OFF
SET SERVEROUTPUT OFF

-- Es realitza un procediment per executar el test.
CREATE OR REPLACE PROCEDURE runTestsTasca98 IS
  ut_obj tasca98_test_obj := tasca98_test_obj();
BEGIN
  ut_obj.run_tests;
END;
/

SET SERVEROUTPUT ON
SET TERMOUT ON
SHOW ERRORS;
SET TERMOUT OFF
SET SERVEROUTPUT OFF