<meta http-equiv="content-type" content="application/xhtml+xml; charset=utf-8" />

Disseny i implementació d'una base de dades relacional per a un concessionari de vehicles
=========================================================================================

## Apunts generals

En les descripcions dels camps, si no és que s'especifica el contrari, els camps són obligatoris.

Tasca 48: Identificar les entitats implicades a la compra d'un vehicle
----------------------------------------------------------------------

En aquesta tasca s'han identificat les següents entitats:

- **Botigues**: És l'entitat que representa cada una de les botigues del concessionari. Com indica la història d'usuari, es consideren les dades següents:
  1. Nom: Consistirà en una cadena de caràcters de 100 caràcters com a màxim.
  2. Adreça: Consistirà en una cadena de caràcters amb longitud màxima de 200.
  3. Telèfon: Consistirà en una cadena de caràcters de 9 caràcters com a màxim. Només s'han considerat numeracions nacionals.
  4. Fax: Consistirà en una cadena de caràcters amb les mateixes consideracions que el telèfon.
  5. Correu-e: Consistirà en una cadena de caràcters de 50 caràcters com a màxim.

> A més, es considerarà també un codi enter identificatiu únic, que serà camp clau.

- **Empleats**: Es considera necessari poder identificar a l'empleat que realitza la compra com una entitat pròpia. A més, la utilització d'aquesta entitat permet simplificar la definició de la relació que representen les compres, que es defineix a l'últim punt d'aquesta enumeració. Es consideren els següents camps:
  1. NIF: Consistirà en una cadena de caràcters de màxim 9 caràcters, considerant la numeració del NIF. Serà el camp clau.
  1. Nom: Consistirà en una cadena de caràcters de 200 caràcters com a màxim.
  1. Codi Botiga: Necessari per implementar la relació 1:N amb l'entitat Botigues, per tant, consistirà en un enter.

- **Vehicles**: Representarà cada un dels vehicles. Per a la identificació del vehicle s'ha triat el _VIN_, o número de bastidor, ja que no tots els vehicles han de tenir matrícula. En cas que el vehicle no tingui vehicle, la compra es considerarà de primera mà; si, pel contrari, en té, aleshores, la compra s'haurà de considerar de segona mà. L'enumeració de dades recollides és la següent:
  1. VIN: Consistirà en una cadena de caràcters de 17 caràcters, basant-se en la definició que es dòna a la [Viquipèdia][VIN]
  2. Matrícula: Consistirà en una cadena de caràcters de longitud màxima de 7 caràcters, ja que només s'han considerat matrícules nacionals. No és obligatòria la seva presència.
  3. Marca: Consistirà en una cadena de caràcters de, com a màxim, 30 caràcters.
  4. Model: Consistirà en una cadena de caràcters amb una longitud màxima de 50 caràcters.
  5. Motor: Consistirà en una cadena de caràcters de 50 caràcters com a màxim.
  6. Equipament: Consistirà en una cadena de caràcters de 200 caràcters de mida màxima.
  7. Color: Consistirà en una cadena de caràcters amb un màxim de 20 caràcters.

> Cal destacar que no s'ha considerat, ja que no s'ha indicat a la història d'usuari, la possibilitat d'estandaritzar la descripció del vehicle, a nivell de marca, model, motor, color, equipament.

- **Venedors**: Aquesta entitat representa l'individu, empresa o institució a la que se li compra un nou vehicle i se'n consideren els següents camps:
  1. NIF: Consistirà en una cadena de caràcters de màxim 9 caràcters, considerant la numeració del NIF. Serà el camp clau.
  1. Nom: Consistirà en una cadena de caràcters de 200 caràcters com a màxim.
  2. Adreça: Consistirà en una cadena de caràcters amb longitud màxima de 200.
  3. Telèfon: Consistirà en una cadena de caràcters de 9 caràcters com a màxim. Només s'han considerat numeracions nacionals.
  4. Fax: Consistirà en una cadena de caràcters amb les mateixes consideracions que el telèfon.
  5. Correu-e: Consistirà en una cadena de caràcters de 50 caràcters com a màxim.

Com que la compra quedaria representada per una relació a tres bandes entre Emplears, Vehicles i Venedors, cal implementar una entitat explícita per representar-la:

- **Compres**: La clau de la cual estarà composta pels NIFs de l'Empleat i del Venedor, el VIN del Vehicle i la Data de la compra. Considera els següents camps:
  1. NIF Empleat: Consistirà en una cadena de caràcters de màxim 9 caràcters, considerant la numeració del NIF.
  1. NIF Venedor: Com l'anterior.
  1. VIN Vehicle: Consistirà en una cadena de caràcters de 17 caràcters, basant-se en la definició que es dòna a la [Viquipèdia][VIN]
  1. Data de la compra: Serà un camp de tipus data que no contindrà l'hora, doncs no cal.
  1. Import: Serà un camp de tipus numèric amb dos decimals, que representarà l'import de la compra en Euros.

Tasca 49: Identificar i protoripar els processos implicats en la compra d'un vehicle
------------------------------------------------------------------------------------

En relació amb la compra d'un vehicle, s'han identificat els següents processos requerits:

- **Addició d'un nou venedor**: Utilitzat únicament en el cas que s'hagi d'incloure un nou venedor al que se li està comprant un cotxe. El seu prototip seria:

        nouVenedor(NIF, Nom, Adreça, Telèfon, Fax, Correu-e)

- **Compra d'un nou vehicle**: Realitzarà la compra efectiva. El seu prototip és:

        compra(NIF Empleat, NIF Venedor, VIN, Matrícula, Marca, Model, Motor, Equipament, Color, Data de la Compra, Import)

No es considera que la compra d'un vehicle hagi de proveïr la incorporació d'un nou empleat ni l'addició de noves botigues, per tant, els tests hauran de proveïr-ne les dades d'aquestes entitats explícitament. Aquesta consideració no s'aplica per als venedors ja que es considera el cas en què s'estigui fent una compra a algú que ha dut un vehicle per vendre'l per primer cop.

Tasca 52: Ampliar el disseny per incloure'n un registre de les accions preses per l'aplicació
---------------------------------------------------------------------------------------------

En aquesta tasca s'han identificat les següents entitats:

- **Registres**: És l'entitat que representa cada registre. Consta dels següents camps:
  1. Codi: És el camp clau, consistent en un nombre enter incrementat automàticament.
  2. Nom funció: És el nom de la funció que ha provocat el registre i es representa com una cadena de caràcters amb longitud màxima de 100 caràcters.
  3. Data registre: És el moment en què s'ha produït el registre, ha d'incorporar la màxima precisió possible.

- **Atributs**: És l'entitat que representa diferents atributs per cada registre. S'ha considerat que, com hi haurà diferents atributs implicats depenent de l'acció que s'estigui registrant, convé permetre indicar una llista clau-valor d'atributs. La clau es compondrà de l'identificador del registre al què correspon i del nom de l'atribut. Conté els següents camps:
  1. Codi Registre: És el camp clau que identifica el registre, per tant és un enter.
  2. Nom: Representa, amb una cadena de caràcters de 100 octets de longitud, el nom de l'atribut que representa.
  3. Valor: Conté el valor en una cadena de caràcters de 200 octets de longitud.
  4. Tipus: Conté el nom del tipus de valor, en una cadena de caràcters de 200 octets de longitud.

S'hauran d'implementar la següent operació:

- **Addició d'un nou event**: Enregistrarà una acció que s'ha realitzat, amb el següent prototip:

        registra(Nom funció, Atributs)

Tasca 55: Dissenyar els elements necessaris per les estadístiques de les compres de vehicles
--------------------------------------------------------------------------------------------

Aquesta tasca implica crear els cubs OLAP utilitzant técniques ROLAP, ja que l'Oracle és relacional i no multidimensional. Pel que fa al disseny OLAP, s'ha triat utilitzar un esquema d'estrella per simplicitat. En cas que, més endavant, es veiés necessari, per exemple, posar categorització en diferents nivells.
S'ha considerat crear una taula de fets per les compres i s'han considerat les dimensions venedors, botigues, empleats, vehicles i temps. Pel que fa a la granularitat de la dimensió de temps, es considerarà diària. A més, també amb granularitat diària, es consideren taules agregades per resoldre els dubtes més generals, si bé, fins a aquest moment, no s'ha definit cap dubte sobre les compres.
El model físic que s'ha definit és basa en els camps del model físic OLTP de l'aplicació. Val a dir que s'emmagatzemen, per totes les dimensions, els mateixos camps amb els mateixos formats. Una de les principals diferències és que les claus primàries del model OLTP no es consideraran vàlides, només les que tinguin algun significat (com els NIF o el VIN) es mantindran en el model OLAP, peró ja no com a camps clau. Per a totes les dimensions, els camps clau serán numèrics autogenerats.
El model físic resultant és com segueix:

- **Dimensió Empleats**:
  1. Id
  2. NIF
  3. Nom

- **Dimensió Botigues**:
  1. Id
  2. Nom
  3. Adreça
  4. Telèfon
  5. Fax
  6. Correu-e

- **Dimensió Venedors**:
  1. Id
  2. NIF
  3. Nom
  4. Adreça
  5. Telèfon
  6. Fax
  7. Correu-e

- **Dimensió Vehicles**:
  1. Id
  2. VIN
  3. Matrícula
  4. Marca
  5. Model
  6. Color
  7. Motor
  8. Equipament

- **Dimensió Temps**:
  1. Id
  2. Data
  3. Any
  4. Trimestre
  5. Mes
  6. Setmana
  7. Dia de la setmana

- **Fets Compres**:
  1. Id Empleat
  2. Id Botiga
  3. Id Venedor
  4. Id Vehicle
  5. Id Temps
  6. Import

  [VIN]: http://en.wikipedia.org/wiki/Vehicle_Identification_Number#Components_of_the_VIN "Descripció del VIN a la Viquipèdia"
