<meta http-equiv="content-type" content="application/xhtml+xml; charset=utf-8" />

Disseny i implementació d'una base de dades relacional per a un concessionari de vehicles
=========================================================================================

## Apunts generals

En les descripcions dels camps, si no és que s'especifica el contrari, els camps són obligatoris.

Tasca 58: Identificar les entitats implicades a la venda d'un vehicle
----------------------------------------------------------------------

En aquesta tasca s'han identificat les següents entitats, a més de les que ja existien:

- **Clients**: És l'entitat que representa els clients que compren els vehicles a les botigues. Com indica la història d'usuari, es consideren les dades següents:
  1. NIF: Consistirà en una cadena de caràcters de màxim 9 caràcters, considerant la numeració del NIF. Serà el camp clau.
  1. Nom: Consistirà en una cadena de caràcters de 100 caràcters com a màxim.
  2. Adreça: Consistirà en una cadena de caràcters amb longitud màxima de 200.
  3. Telèfon: Consistirà en una cadena de caràcters de 9 caràcters com a màxim. Només s'han considerat numeracions nacionals.
  4. Fax: Consistirà en una cadena de caràcters amb les mateixes consideracions que el telèfon.
  5. Correu-e: Consistirà en una cadena de caràcters de 50 caràcters com a màxim.

- **Comercials**: És una entitat que hereta de l'entitat **Empleats**. No té cap camp addicional, peró permet establir la diferència entre un empleat i un comercial. Com hereta de **Empleats** contindrà el camp NIF, que serà clau forània i primària, a l'hora.

> Per aquesta entitat, s'han contemplat altres opcions:
> - No implementar res més que la relació entre les vendes i els empleats. El problema que presenta aquesta opció és que, en el moment de veure quants cotxes ha venut cada comercial, en no poder-se diferenciar entre els empleats els que són comercials, es podrien donar més entrades de les que realment es volen.
> - Afegir un camp diferencial a l'entitat d'empleats. Aquesta opció considera que hi ha més categories i, com fins ara no han estat necessàries, convindria establir-les totes.

Com que la compra quedaria representada per una relació a tres bandes entre Comercials, Vehicles i Clients, cal implementar una entitat explícita per representar-la:

- **Vendes**: La clau de la cual estarà composta pels NIFs del Comercial i del Client, el VIN del Vehicle i la Data de la venda. Considera els següents camps:
  1. NIF Comercial: Consistirà en una cadena de caràcters de màxim 9 caràcters, considerant la numeració del NIF.
  1. NIF Clients: Com l'anterior.
  1. VIN Vehicle: Consistirà en una cadena de caràcters de 17 caràcters, basant-se en la definició que es dòna a la [Viquipèdia][VIN]
  1. Data de la venda: Serà un camp de tipus data que no contindrà l'hora, doncs no cal.
  1. Import: Serà un camp de tipus numèric amb dos decimals, que representarà l'import de la venda en Euros.

Tasca 59: Identificar i protoripar els processos implicats en la venda d'un vehicle
------------------------------------------------------------------------------------

En relació amb la venda d'un vehicle, s'han identificat els següents processos requerits:

- **Addició d'un nou client**: Utilitzat únicament en el cas que s'hagi d'incloure un nou client al que se li està venent un cotxe. El seu prototip seria:

        nouClient(NIF, Nom, Adreça, Telèfon, Fax, Correu-e)

- **Venda d'un nou vehicle**: Realitzarà la venda efectiva. El seu prototip és:

        venda(NIF Comercial, NIF Client, VIN Vehicle, Data de la Compra, Import)

Tasca 65: Verificar el subsistema de registre d'accions per la història de venda d'un vehicle
---------------------------------------------------------------------------------------------

No s'han considerat tasques addicionals necessàries ja que tant el disseny del model com dels processos existents per gestinoar-los són suficients per a les necessitats que es presenten en aquesta història d'usuari.

Tasca 62: Dissenyar els elements necessaris per les estadístiques de les vendes de vehicles
--------------------------------------------------------------------------------------------

- **Dimensió Comercials**:
  1. Id
  2. NIF
  3. Nom

S'ha afegit l'atribut Nom a la dimensió Comercials per tal d'evitar relacions, i per tant cerques, a la dimensió Empleats.

- **Dimensió Clients**:
  1. Id
  2. NIF
  3. Nom
  4. Adreça
  5. Telèfon
  6. Fax
  7. Correu-e

- **Fets Vendes**:
  1. Id Comercial
  2. Id Botiga
  3. Id Client
  4. Id Vehicle
  5. Id Temps
  6. Import

  [VIN]: http://en.wikipedia.org/wiki/Vehicle_Identification_Number#Components_of_the_VIN "Descripció del VIN a la Viquipèdia"
