<meta http-equiv="content-type" content="application/xhtml+xml; charset=utf-8" />

Disseny i implementació d'una base de dades relacional per a un concessionari de vehicles
=========================================================================================

Introducció al directori test
-----------------------------

En aquest directori es pot trobar la implementació de la plataforma utilitzada per al desenvolupament i execució dels tests del projecte.

Requeriments
------------

Per a poder utilitzar aquesta plataforma, és necessari disposar de les següents eines a l'equip de treball:
* *Oracle VirtualBox*, que és l'hipervisor que s'utilitza per a virtualitzar un servidor en el que es fa la instal·lació del programari.
* *Vagrant*, que és l'eina que s'utilitza per a automatitzar-ne l'aprovisionament de la plataforma
* *Mercurial*, que és l'eina amb la què es fa la gestió de la configuració del projecte.

També cal tenir clonat el repositori, peró pel simple fer d'estar llegint aquest document, ja s'entén que s'ha fet prèviament.
D'altra banda, és necessari estar connectat a Internet per a poder-la utilitzar, ja que es descarregarà alguns fitxers. Aquestes descàrregues, especialment la de la base de dades Oracle, poden ser de mida considerable, per la qual cosa, amb connexions a Internet amb molt poc ample de banda o amb alta latència, podria ser que enlentissin considerablement algunes operacions.

Configuració
------------

La plataforma s'aprovisiona i gestiona amb *Vagrant*, que utilitza el fitxer <code>Vagrantfile</code>, per conèixer els detalls del sistema que necessita aprovisionar. Aquest fitxer defineix el següent:
* S'utilitzarà una imatge d'Ubuntu Lucid 10.04 de 32 bits.
* A banda de la redirecció del port 2222/tcp del sistema hoste al port 22/tcp del sistema hospedat, que es fa automàticament per Vagrant, es configuraran, també, la redirecció dels ports 8080/tcp i 1521/tcp del sistema hoste als mateixos ports del sistema hospedat. Així s'aconsegueix accés des del sistema local a l'APEX i el listener de l'oracle que s'hi instal·larà.
* El sistema hospedat requereix, per poder instal·lar convenientment la base de dades Oracle 10g, que es disposi de 2 Gigabytes de memòria.
* Finalment, se li indica que cal que aprovisioni la recepta <code>pfc</code> utilitzant el sistema Chef, que es descriu tot seguit.

Chef és un sistema d'aprovisionament que permet automatitzar tasques d'aprovisionament en un sistema ja funcional i en garanteix la seva integritat. Aquest sistema funciona a partir d'unes receptes que es desenvolupen per tal de configurar el sistema fins que assoleix l'estat desitjat.
En el cas concret d'aquest projecte, s'han implementat dues receptes:
* *oracle-xe*: Aquesta recepta indica els passos que s'han de seguir per tal de poder disposar d'una base de dades Oracle 10g. Aquests passos consisteixen en:
  1. Fer una actualització dels repositoris d'Ubuntu, actualitzant-ne el software ja instal·lat en el sistema.
  2. Descarregar el paquet instal·lable per Debian de la llibreria AIO d'Oracle. Aquesta operació pot trigar una mica, peró està dissenyada de forma que un cop aprovisionada un cop en l'equip de treball, no torni a trigar tant.
  3. Descarregar el paquet instal·lable per Debian de la base de dades Oracle 10g Express. Aquesta operació pot trigar una mica, peró està dissenyada de forma que un cop aprovisionada un cop en l'equip de treball, no torni a trigar tant.
  4. Instal·lar el paquet bc, necessari per la instal·lació d'Oracle.
  5. Instal·lar la libAIO i l'Oracle 10g Express.
  6. Configurar l'entorn de sessió per l'usuari oracle del sistema, que s'ha creat automàticament en instal·lar l'Oracle 10g Express.
  7. Executar la configuració de l'Oracle 10g Express, fent servir les respostes ja guardades al fitxer <code>files/oracle-xe-setup.txt</code>.
  8. Activar l'accés a l'APEX de l'Oracle a través de xarxa.
* *pluto*: Aquesta recepta descarrega i instal·la les llibreries PL/SQL per a fer testeig unitari. Aquestes llibreries s'han de descarregar d'Internet, descomprimir i instal·lar dins de l'Oracle.
* *pfc*: Aquesta recepta instal·la el mercurial al sistema hospedat, es connecta al mercurial local del sistema hoste, que s'ha d'haver activat per servir prèviament, i instal·la els components del projecte.

Utilització
-----------

Per tal d'aprovisionar la plataforma per primer cop, només cal executar, des del directori pare del repositori:
  hg serve
  cd test
  vagrant up

Aquesta operació pot donar, puntualment, alguns problemes, però aleshores caldria destruir l'entorn per tornar-lo a aprovisionar.
Per a destruir l'entorn, s'utilitza la comanda:
  vagrant destroy -f

Aquesta destrucció significa l'eliminació del sistema hospedat. Si es desitja només aturar-lo, es pot aconseguir amb la comanda:
  vagrant halt

Per tornar-lo a aixecar, caldrà utilitzar la mateixa comanda que per aprovisionar-lo.
Un cop el sistema s'ha aprovisionat correctament, es pot accedir a l'Oracle a través de l'APEX, utilitzant l'adreça http://localhost:8080/apex, o a través del listener, utilitzant la següent cadena de connexió:
  XE =
    (DESCRIPTION =
      (ADDRESS = (PROTOCOL = TCP)(HOST = 127.0.0.1)(PORT = 1521))
      (CONNECT_DATA = (SERVICE_NAME = XE))
    )
