#
# Cookbook Name:: oracle-xe
# Recipe:: default
#
# Copyright 2012, Ignasi Fosch Alonso
#
# All rights reserved - Do Not Redistribute
#
vagrantChefPath = "/tmp/vagrant-chef-1/chef-solo-1"
oracleXECookbookFiles = "#{vagrantChefPath}/cookbooks/oracle-xe/files"

execute "upgrade" do
	command "apt-get -y update && apt-get -y upgrade"
end

execute "downloadLibAio" do
	command "wget http://oss.oracle.com/debian/dists/unstable/main/binary-i386/libaio_0.3.104-1_i386.deb -O #{oracleXECookbookFiles}/libaio_0.3.104-1_i386.deb"
	creates "#{oracleXECookbookFiles}/libaio_0.3.104-1_i386.deb"
end

execute "downloadOracle" do
	command "wget http://oss.oracle.com/debian/dists/unstable/non-free/binary-i386/oracle-xe_10.2.0.1-1.1_i386.deb -O #{oracleXECookbookFiles}/oracle-xe_10.2.0.1-1.1_i386.deb"
	creates "#{oracleXECookbookFiles}/oracle-xe_10.2.0.1-1.1_i386.deb"
end

execute "installBC" do
	command "apt-get install bc"
	not_if "test -x /usr/bin/bc"
end

execute "installOracle" do
	command "dpkg -i #{oracleXECookbookFiles}/libaio_0.3.104-1_i386.deb #{oracleXECookbookFiles}/oracle-xe_10.2.0.1-1.1_i386.deb"
	not_if "test -f /usr/lib/oracle/xe/.profile"
end

execute "configureOracle" do
	command "/etc/init.d/oracle-xe configure < #{oracleXECookbookFiles}/oracle-xe-setup.txt"
	not_if "test -f /usr/lib/oracle/xe/.profile"
end

cookbook_file "/usr/lib/oracle/xe/.profile" do
	source "oracle.profile"
	owner "oracle"
	group "dba"
	mode 0755
	not_if "test -f /usr/lib/oracle/xe/.profile"
end

execute "enableAPEXAccess" do
	command "sudo -iu oracle 'echo \"EXEC DBMS_XDB.SETLISTENERLOCALACCESS(FALSE);\" | sqlplus / as sysdba'"
end
